--- old/usr/src/lib/libdisasm/common/libdisasm.c	2014-08-01 15:57:44.436512777 -0400
+++ new/usr/src/lib/libdisasm/common/libdisasm.c	2014-08-01 15:57:44.442084738 -0400
@@ -23,12 +23,17 @@
  * Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  * Copyright 2012 Joshua M. Clulow <josh@sysmgr.org>
+ * Copyright 2014 Nexenta Systems, Inc.  All rights reserved.
  */
 
 #include <libdisasm.h>
 #include <stdlib.h>
 #ifdef DIS_STANDALONE
 #include <mdb/mdb_modapi.h>
+#define	_MDB
+#include <mdb/mdb_io.h>
+#else
+#include <stdio.h>
 #endif
 
 #include "libdisasm_impl.h"
@@ -214,3 +219,26 @@
 {
 	return (dhp->dh_arch->da_instrlen(dhp, pc));
 }
+
+int
+dis_vsnprintf(char *restrict s, size_t n, const char *restrict format,
+    va_list args)
+{
+#ifdef DIS_STANDALONE
+	return (mdb_iob_vsnprintf(s, n, format, args));
+#else
+	return (vsnprintf(s, n, format, args));
+#endif
+}
+
+int
+dis_snprintf(char *restrict s, size_t n, const char *restrict format, ...)
+{
+	va_list args;
+
+	va_start(args, format);
+	n = dis_vsnprintf(s, n, format, args);
+	va_end(args);
+
+	return (n);
+}
